Index: tests/regressiontests/admin_scripts/tests.py
===================================================================
--- tests/regressiontests/admin_scripts/tests.py	(revision 17914)
+++ tests/regressiontests/admin_scripts/tests.py	(working copy)
@@ -3,7 +3,6 @@
 advertised - especially with regards to the handling of the DJANGO_SETTINGS_MODULE
 and default settings.py files.
 """
-
 import os
 import re
 import shutil
@@ -13,14 +12,15 @@
 
 from django import conf, bin, get_version
 from django.conf import settings
+from django.db import connection
 from django.test.simple import DjangoTestSuiteRunner
 from django.utils import unittest
 from django.test import LiveServerTestCase
 
+from .models import Article
+
 test_dir = os.path.dirname(os.path.dirname(__file__))
-expected_query_re = re.compile(r'CREATE TABLE [`"]admin_scripts_article[`"]', re.IGNORECASE)
 
-
 class AdminScriptTestCase(unittest.TestCase):
     def write_settings(self, filename, apps=None, is_dir=False, sdict=None):
         test_dir = os.path.dirname(os.path.dirname(__file__))
@@ -844,6 +844,8 @@
     """
     def setUp(self):
         self.write_settings('alternate_settings.py')
+        tblname = connection.qname(Article)
+        self.expected_query_re = re.compile(r'CREATE TABLE %s' % tblname, re.IGNORECASE)
 
     def tearDown(self):
         self.remove_settings('alternate_settings.py')
@@ -859,14 +861,14 @@
         "alternate: manage.py builtin commands work with settings provided as argument"
         args = ['sqlall', '--settings=alternate_settings', 'admin_scripts']
         out, err = self.run_manage(args)
-        self.assertRegexpMatches(out, expected_query_re)
+        self.assertRegexpMatches(out, self.expected_query_re)
         self.assertNoOutput(err)
 
     def test_builtin_with_environment(self):
         "alternate: manage.py builtin commands work if settings are provided in the environment"
         args = ['sqlall', 'admin_scripts']
         out, err = self.run_manage(args, 'alternate_settings')
-        self.assertRegexpMatches(out, expected_query_re)
+        self.assertRegexpMatches(out, self.expected_query_re)
         self.assertNoOutput(err)
 
     def test_builtin_with_bad_settings(self):
Index: tests/regressiontests/introspection/tests.py
===================================================================
--- tests/regressiontests/introspection/tests.py	(revision 17914)
+++ tests/regressiontests/introspection/tests.py	(working copy)
@@ -2,7 +2,8 @@
 
 from functools import update_wrapper
 
-from django.db import connection
+from django.conf import settings
+from django.db import connection, QName
 from django.test import TestCase, skipUnlessDBFeature, skipIfDBFeature
 
 from .models import Reporter, Article
@@ -39,24 +40,29 @@
     __metaclass__ = IgnoreNotimplementedError
 
     def test_table_names(self):
-        tl = connection.introspection.table_names()
-        self.assertTrue(Reporter._meta.db_table in tl,
+        conv = connection.introspection.qname_converter
+        tl = connection.introspection.all_qualified_names()
+        self.assertTrue(conv(Reporter._meta.qualified_name) in tl,
                      "'%s' isn't in table_list()." % Reporter._meta.db_table)
-        self.assertTrue(Article._meta.db_table in tl,
+        self.assertTrue(conv(Article._meta.qualified_name) in tl,
                      "'%s' isn't in table_list()." % Article._meta.db_table)
 
     def test_django_table_names(self):
         cursor = connection.cursor()
-        cursor.execute('CREATE TABLE django_ixn_test_table (id INTEGER);')
+        tblname = connection.ops.qualified_name(
+            QName(None, 'django_ixn_test_table', False))
+        cursor.execute('CREATE TABLE %s (id INTEGER);' % tblname)
         tl = connection.introspection.django_table_names()
-        cursor.execute("DROP TABLE django_ixn_test_table;")
-        self.assertTrue('django_ixn_testcase_table' not in tl,
+        cursor.execute("DROP TABLE %s;" % tblname)
+        self.assertTrue(tblname not in tl,
                      "django_table_names() returned a non-Django table")
 
     def test_django_table_names_retval_type(self):
         # Ticket #15216
         cursor = connection.cursor()
-        cursor.execute('CREATE TABLE django_ixn_test_table (id INTEGER);')
+        tblname = connection.ops.qualified_name(
+            QName(None, 'django_ixn_test_table', False))
+        cursor.execute('CREATE TABLE %s (id INTEGER);' % tblname)
 
         tl = connection.introspection.django_table_names(only_existing=True)
         self.assertIs(type(tl), list)
@@ -65,25 +71,30 @@
         self.assertIs(type(tl), list)
 
     def test_installed_models(self):
-        tables = [Article._meta.db_table, Reporter._meta.db_table]
+        conv = connection.introspection.qname_converter
+        tables = [conv(Article._meta.qualified_name),
+                  conv(Reporter._meta.qualified_name)]
         models = connection.introspection.installed_models(tables)
         self.assertEqual(models, set([Article, Reporter]))
 
     def test_sequence_list(self):
         sequences = connection.introspection.sequence_list()
-        expected = {'table': Reporter._meta.db_table, 'column': 'id'}
+        qname = connection.introspection.qname_converter(Reporter._meta.qualified_name)
+        expected = {'qname': qname, 'column': 'id'}
         self.assertTrue(expected in sequences,
                      'Reporter sequence not found in sequence_list()')
 
     def test_get_table_description_names(self):
         cursor = connection.cursor()
-        desc = connection.introspection.get_table_description(cursor, Reporter._meta.db_table)
+        tbl = connection.introspection.qname_converter(Reporter._meta.qualified_name)
+        desc = connection.introspection.get_table_description(cursor, tbl)
         self.assertEqual([r[0] for r in desc],
                          [f.column for f in Reporter._meta.fields])
 
     def test_get_table_description_types(self):
         cursor = connection.cursor()
-        desc = connection.introspection.get_table_description(cursor, Reporter._meta.db_table)
+        tbl = connection.introspection.qname_converter(Reporter._meta.qualified_name)
+        desc = connection.introspection.get_table_description(cursor, tbl)
         self.assertEqual(
             [datatype(r[1], r) for r in desc],
             ['IntegerField', 'CharField', 'CharField', 'CharField', 'BigIntegerField']
@@ -95,7 +106,8 @@
     @skipIfDBFeature('interprets_empty_strings_as_nulls')
     def test_get_table_description_nullable(self):
         cursor = connection.cursor()
-        desc = connection.introspection.get_table_description(cursor, Reporter._meta.db_table)
+        tbl = connection.introspection.qname_converter(Reporter._meta.qualified_name)
+        desc = connection.introspection.get_table_description(cursor, tbl)
         self.assertEqual(
             [r[6] for r in desc],
             [False, False, False, False, True]
@@ -105,35 +117,51 @@
     @skipUnlessDBFeature('has_real_datatype')
     def test_postgresql_real_type(self):
         cursor = connection.cursor()
-        cursor.execute("CREATE TABLE django_ixn_real_test_table (number REAL);")
-        desc = connection.introspection.get_table_description(cursor, 'django_ixn_real_test_table')
-        cursor.execute('DROP TABLE django_ixn_real_test_table;')
+        tblname = connection.ops.qualified_name(
+            QName(None, 'django_ixn_real_test_table', False))
+        cursor.execute("CREATE TABLE %s (number REAL);" % tblname)
+        desc = connection.introspection.get_table_description(
+            cursor, QName(None, 'django_ixn_real_test_table', False))
+        cursor.execute('DROP TABLE %s;' % tblname)
         self.assertEqual(datatype(desc[0][1], desc[0]), 'FloatField')
 
     def test_get_relations(self):
         cursor = connection.cursor()
-        relations = connection.introspection.get_relations(cursor, Article._meta.db_table)
+        tbl = connection.introspection.qname_converter(Article._meta.qualified_name)
+        relations = connection.introspection.get_relations(cursor, tbl)
+        rep_tbl = connection.introspection.qname_converter(Reporter._meta.qualified_name)
 
         # Older versions of MySQL don't have the chops to report on this stuff,
         # so just skip it if no relations come back. If they do, though, we
         # should test that the response is correct.
         if relations:
             # That's {field_index: (field_index_other_table, other_table)}
-            self.assertEqual(relations, {3: (0, Reporter._meta.db_table)})
+            # We have a small problem here: the Reporter model is installed
+            # into the default schema (qualified_name[0] == None). The
+            # relation introspection is going to see it in that schema, but we
+            # do not know what that schema is. So, test everything except the
+            # schema.
+            # TODO: this testing logic is UGLY!
+            schema = connection.convert_schema(Reporter._meta.qualified_name[0])
+            self.assertTrue(3 in relations)
+            relations[3] = (relations[3][0], (schema, relations[3][1][1], True))
+            self.assertEqual(relations, {3: (0, rep_tbl)})
 
     def test_get_key_columns(self):
         cursor = connection.cursor()
-        key_columns = connection.introspection.get_key_columns(cursor, Article._meta.db_table)
-        self.assertEqual(key_columns, [(u'reporter_id', Reporter._meta.db_table, u'id')])
+        rep_tbl = connection.introspection.qname_converter(Reporter._meta.qualified_name, force_schema=True)
+        key_columns = connection.introspection.get_key_columns(cursor, Article._meta.qualified_name)
+        self.assertEqual(key_columns, [(u'reporter_id', rep_tbl, u'id')])
 
     def test_get_primary_key_column(self):
         cursor = connection.cursor()
-        primary_key_column = connection.introspection.get_primary_key_column(cursor, Article._meta.db_table)
+        primary_key_column = connection.introspection.get_primary_key_column(cursor, Article._meta.qualified_name)
         self.assertEqual(primary_key_column, u'id')
 
     def test_get_indexes(self):
         cursor = connection.cursor()
-        indexes = connection.introspection.get_indexes(cursor, Article._meta.db_table)
+        tbl = connection.introspection.qname_converter(Article._meta.qualified_name)
+        indexes = connection.introspection.get_indexes(cursor, tbl)
         self.assertEqual(indexes['reporter_id'], {'unique': False, 'primary_key': False})
 
 
